;This is for rebuilding the debug menu.
;ROM: Secret of Evermore (U) [!].smc
;     Size: 3145728 Bytes (exactly 3MB)
;     CRC: 836922997 (linux cksum)
;ROM needs to be extended up to 4MB, so paste 1048576 bytes at the end.
;header
hirom

; NOP-out a RTS that that makes it impossible to access the debug ring.
ORG $CEA3EA
NOP

; Hook into the routine that loads the config ring.
ORG $CE9A86
JSL $FE0000  ; Jump to extended space to load the debug ring.
NOP          ; \ NOP-out original code we will repeat in extended space.
NOP          ; /

; Go to extended space to load the debug ring.
ORG $FE0000
LDA #$0016   ; \ Repeat a part of the original code that loads the config ring.
STA $0814    ; /
LDA #$000B   ; \
STA $0F5A    ;  |
LDA #$000A   ;  |
STA $0F5C    ;  |
LDA #$0000   ;  |
STA $0F5E    ;  |
LDA #$0002   ;  |
STA $0F60    ;  |
LDA #$0004   ;  |
STA $0F62    ;  |
LDA #$0006   ;  |
STA $0F64    ;  |
LDA #$0008   ;  | Load the debug ring items.
STA $0F66    ;  |
LDA #$000A   ;  |
STA $0F68    ;  |
LDA #$000C   ;  |
STA $0F6A    ;  |
LDA #$000E   ;  |
STA $0F6C    ;  |
LDA #$0010   ;  |
STA $0F6E    ;  |
LDA #$0012   ;  |
STA $0F70    ;  |
LDA #$0014   ;  |
STA $0F72    ; /
RTL          ; Jump back to original code to finish loading the config ring.

; Hook into the routine that executes the corresponding item code when clicking on it (in config ring).
ORG $CEA439  ; This is a LDA we will repeat in extended space.
JSL $FE0100  ; Jump to extended space.

ORG $FE0100  ; Go to extended space.
LDA $8E0006,x; Repeat original code we overwrote by a long jump.
             ; Now check for clicked item in the debug ring and long jump (JML without return) to the corresponding
             ; routine. Y-Register holds RAM-Address of selected item so it is easy to check for debug items.
CPY #$0F5A   ; \
BNE $04      ;  | Create a monster (not implemented yet)
JMP $FE0200  ; /
CPY #$0F5C   ; \
BNE $04      ;  | Heel
JMP $CE98C0  ; /
CPY #$0F5E   ; \
BNE $04      ;  | Show thud balls on path (not implemented yet)
JMP $FE0200  ; / 
CPY #$0F60   ; \
BNE $04      ;  | Turn off both backgrounds
JMP $CE9796  ; /
CPY #$0F62   ; \
BNE $04      ;  | Show background 1 only
JMP $CE97B1  ; /
CPY #$0F64   ; \
BNE $04      ;  | Show background 2 only
JMP $CE97CA  ; /
CPY #$0F66   ; \
BNE $04      ;  | Show both backgrounds
JMP $CE97E3  ; /
CPY #$0F68   ; \
BNE $04      ;  | Select map (not implemented yet)
JMP $FE0200  ; /
CPY #$0F6A   ; \
BNE $04      ;  | Mode 7 flight
JMP $CE983E  ; /
CPY #$0F6C   ; \
BNE $04      ;  | Alchemist
JMP $CE95A6  ; /
CPY #$0F6E   ; \
BNE $04      ;  | ROM Creation Date
JMP $CE96A7  ; /
RTL          ; Item was not from the debug ring, so go back to normal execution.

; Write a routine that says 'Not implemented yet' for debug items with missing function pointer.
; It is the same as the ROM Creation Date routine but with new text.
ORG $FE0200  ; Go to extended space.
LDA #$0220   ; Load ROM address of text (not bank related, see ROM in hex editor at $B72C)
STA $22      ; Save the address to RAM
LDA #$00FE   ; Load bank related to the address
STA $24      ; Save bank to RAM
JSL $8CC521  ;
JMP $CEAD67  ;
ORG $FE0220  ; Go right behind the above routine.
db $4E       ; \  N
db $6F       ;  | o
db $74       ;  | t
db $20       ;  |
db $69       ;  | i
db $6D       ;  | m
db $70       ;  | p
db $6C       ;  | l
db $65       ;  | e
db $6D       ;  | m
db $65       ;  | e
db $6E       ;  | n
db $74       ;  | t
db $65       ;  | e
db $64       ;  | d
db $20       ;  |
db $79       ;  | y
db $65       ;  | e
db $74       ;  | t
db $21       ;  | !
db $00       ;  |
db $00       ; /
