;This is for rebuilding the debug menu including a 'Walk through walls'-hack.
;ROM: Secret of Evermore (U) [!].smc
;     Size: 3145728 Bytes (exactly 3MB)
;     CRC: 836922997 (linux cksum)
;ROM needs to be extended up to 4MB, so paste 1048576 bytes at the end.
;header
hirom

; NOP-out a RTS that that makes it impossible to access the debug ring.
ORG $CEA3EA
NOP

; Hook into the routine that loads the config ring.
ORG $CE9A86
JSL $FE0000  ; Jump to extended space to load the debug ring.
NOP          ; \ NOP-out original code we will repeat in extended space.
NOP          ; /

; Go to extended space to load the debug ring.
ORG $FE0000
LDA #$0016   ; \ Repeat a part of the original code that loads the config ring.
STA $0814    ; /
LDA #$000B   ; \
STA $0F5A    ;  |
LDA #$000A   ;  |
STA $0F5C    ;  |
LDA #$0000   ;  |
STA $0F5E    ;  |
LDA #$0002   ;  |
STA $0F60    ;  |
LDA #$0004   ;  |
STA $0F62    ;  |
LDA #$0006   ;  |
STA $0F64    ;  |
LDA #$0008   ;  | Load the debug ring items.
STA $0F66    ;  |
LDA #$000A   ;  |
STA $0F68    ;  |
LDA #$000C   ;  |
STA $0F6A    ;  |
LDA #$000E   ;  |
STA $0F6C    ;  |
LDA #$0010   ;  |
STA $0F6E    ;  |
LDA #$0012   ;  |
STA $0F70    ;  |
LDA #$0014   ;  |
STA $0F72    ; /
RTL          ; Jump back to original code to finish loading the config ring.

; Hook into the routine that executes the corresponding item code when clicking on it (in config ring).
ORG $CEA439  ; This is a LDA we will repeat in extended space.
JSL $FE0100  ; Jump to extended space.

ORG $FE0100  ; Go to extended space.
LDA $8E0006,x; Repeat original code we overwrote by a long jump.
             ; Now check for clicked item in the debug ring and long jump (JML without return) to the corresponding
             ; routine. Y-Register holds RAM-Address of selected item so it is easy to check for debug items.
CPY #$0F5A   ; \
BNE $04      ;  | Create a monster (not implemented yet)
JMP $FE0200  ; /
CPY #$0F5C   ; \
BNE $04      ;  | Heel
JMP $CE98C0  ; /
CPY #$0F5E   ; \
BNE $04      ;  | Show thud balls on path (not implemented yet)
;JMP $FE0200  ; / NEW: We use this for 'Walk throug walls'-code
JMP $FE0300  ; /
CPY #$0F60   ; \
BNE $04      ;  | Turn off both backgrounds
JMP $CE9796  ; /
CPY #$0F62   ; \
BNE $04      ;  | Show background 1 only
JMP $CE97B1  ; /
CPY #$0F64   ; \
BNE $04      ;  | Show background 2 only
JMP $CE97CA  ; /
CPY #$0F66   ; \
BNE $04      ;  | Show both backgrounds
JMP $CE97E3  ; /
CPY #$0F68   ; \
BNE $04      ;  | Select map (not implemented yet)
JMP $FE0200  ; /
CPY #$0F6A   ; \
BNE $04      ;  | Mode 7 flight
JMP $CE983E  ; /
CPY #$0F6C   ; \
BNE $04      ;  | Alchemist
JMP $CE95A6  ; /
CPY #$0F6E   ; \
BNE $04      ;  | ROM Creation Date
JMP $CE96A7  ; /
RTL          ; Item was not from the debug ring, so go back to normal execution.

; Write a routine that says 'Not implemented yet' for debug items with missing function pointer.
; It is the same as the ROM Creation Date routine but with new text.
ORG $FE0200  ; Go to extended space.
LDA #$0220   ; Load ROM address of text (not bank related, see ROM in hex editor at $B72C)
STA $22      ; Save the address to RAM
LDA #$00FE   ; Load bank related to the address
STA $24      ; Save bank to RAM
JSL $8CC521  ;
JMP $CEAD67  ;
ORG $FE0220  ; Go right behind the above routine.
db $4E       ; \  N
db $6F       ;  | o
db $74       ;  | t
db $20       ;  |
db $69       ;  | i
db $6D       ;  | m
db $70       ;  | p
db $6C       ;  | l
db $65       ;  | e
db $6D       ;  | m
db $65       ;  | e
db $6E       ;  | n
db $74       ;  | t
db $65       ;  | e
db $64       ;  | d
db $20       ;  |
db $79       ;  | y
db $65       ;  | e
db $74       ;  | t
db $21       ;  | !
db $00       ; /


;////////////////////////////////////////////////////
;//               Walk through walls               //
;//                                                //
;// This code gives the player the possibility     //
;// to walk through walls. He can open the         //
;// the debug ring and click on the corresponding  //
;// action. A message is shown and clipping        //
;// will be off until the ring menu is opened      //
;// again.                                         //
;//                                                //
;// Note: We overwrite the 'Debug: Show thud       //
;//       balls on path' item because we have      //
;//       no function pointer for this anyway.     //
;////////////////////////////////////////////////////

; Go to code that checks collision. There exists cheat codes that turn the 'BEQ $03' at $CFAE6F
; into a 'BEQ $70' which turns off collision detection. To make this variable we change a bit more
; code in front of the 'BEQ'.
ORG $CFAE69  ; Go in front of the original code, was 'LDA $0016,y : BIT #$0001' before
JMP $FE0310  ; Jump to extended space
BEQ $72      ; Now insert the 'turn off collision' code in front of the 'BEQ $03'. It is $72 because we
             ; are two bytes ahead. If user wants collision of we will later jump from extended space
             ; directly to this code. Otherwise we will jump to the 'BEQ $03' behind this one to have
             ; normal collision detection.

; Write a routine that writes a 'Walk through wall'-Indicator into RAM.
; We use 'Show thud balls on path'-item position in RAM (upper 8 bits). This would crash the game
; if done while the debug menu is active but not if it inactive. The bits will be overwritten if
; the debug menu appears so using this RAM position is save.
ORG $FE0300
LDA $0F64    ; Load RAM content of item
ORA #$0100   ; \ Save a collision detection indicator into the upper unused byte of the menu item.
STA $0F64    ; /
JMP $FE0330  ; Show message to the user saying that clipping is now off and when it turns on again.

; Modify original code to decide whether we want collision detection or not.
ORG $FE0310  ; Go to extended space
LDA $0F64    ; Load menu item that holds collision detection indicator
AND #$0100   ; Isolate indicator
BEQ $0A      ; If indicator is not present go to original code and have normal collision detection
LDA $0016,y  ; \  Otherwise...
BIT #$0001   ;  | ...repeat original code but...
JMP $CFAE6D  ; /  ...jump to 'no collision code' we inserted into original code
LDA $0016,y  ; \
BIT #$0001   ;  | Execute original code and go to normal collision detection
JMP $CFAE6F  ; /

; Write a routine that says 'Clipping off until ring menu opened!'.
; It is the same as the ROM Creation Date routine but with new text.
ORG $FE0330  ; Go to extended space.
LDA #$0350   ; Load ROM address of text (not bank related, see ROM in hex editor at $B72C)
STA $22      ; Save the address to RAM
LDA #$00FE   ; Load bank related to the address
STA $24      ; Save bank to RAM
JSL $8CC521  ;
JMP $CEAD67  ;
ORG $FE0350  ; Go right behind the above routine.
db $43       ; \  C
db $6C       ;  | l
db $69       ;  | i
db $70       ;  | p
db $70       ;  | p
db $69       ;  | i
db $6E       ;  | n
db $67       ;  | g
db $20       ;  |
db $6F       ;  | o
db $66       ;  | f
db $66       ;  | f
db $20       ;  |
db $75       ;  | u
db $6E       ;  | n
db $74       ;  | t
db $69       ;  | i
db $6C       ;  | l
db $20       ;  |
db $72       ;  | r
db $69       ;  | i
db $6E       ;  | n
db $67       ;  | g
db $20       ;  |
db $6D       ;  | m
db $65       ;  | e
db $6E       ;  | n
db $75       ;  | u
db $20       ;  |
db $6F       ;  | o
db $70       ;  | p
db $65       ;  | e
db $6E       ;  | n
db $65       ;  | e
db $64       ;  | d
db $21       ;  | !
db $00       ; /

; Overwrite original text 'Show thud balls on path' with 'Walk through walls' for ring menu text.
ORG $C465FC
db $57       ; \  W
db $61       ;  | a
db $6C       ;  | l
db $6B       ;  | k
db $20       ;  |
db $74       ;  | t
db $68       ;  | h
db $72       ;  | r
db $6F       ;  | o
db $75       ;  | u
db $67       ;  | g
db $68       ;  | h
db $20       ;  |
db $77       ;  | w
db $61       ;  | a
db $6C       ;  | l
db $6C       ;  | l
db $73       ;  | s
db $00       ; /

;////////////////////////////////////////////////////
;//         END OF Walk through walls code         //
;////////////////////////////////////////////////////